import sys
from pylab import *
import numpy as np
from scipy.io import loadmat, savemat
from util import *

paramfilename = "ws_final.mat"
print paramfilename
param = loadmat(paramfilename)
nrp = 32
nrf1 = int(param["FH"].shape[1])
nrf2 = int(param["w_mean"].shape[1])
nrf = nrf1 + nrf2

d = loadmat('PCAtransform_CIFAR10_experiments.mat')
transform = d["pcatransf"]
sd = d["sd"]
ndim = transform.shape[0]
nrpix = 32
nrp = int(sqrt(transform.shape[1]/3)) # side of patch
stride = int(nrp/2)
steps = int(((32 - nrp)/ stride) + 1)
nrds = 6
feature = np.zeros((10000, nrf, steps, steps),dtype=float)
small = 0.5
 
print "Stride " + str(stride) + ", steps " + str(steps)

for bb in range(nrds):
    print str(bb) + " "
    d = unpickle('/ais/gobi1/kriz/tiny/cifar-10-batches/data_batch_' + str(bb+1)) 
    numcases = d["data"].shape[0]
    batch = reshape(d["data"],(numcases,3,32,32),'C')
    feature = reshape(feature,(numcases,nrf,steps,steps),'F')

    for rr in range(steps):
        #print str(rr)  
        for cc in range(steps):
            #print str(cc)
            chunk = single(reshape(batch[:,:,rr*stride:rr*stride+nrp,cc*stride:cc*stride+nrp],(numcases,3*nrp*nrp),'F')) # PxD
            # preprocessing
            mn = reshape(np.mean(chunk,axis=1),(numcases,1))
            chunk = ((chunk-mn)/sd).copy() # PxD
            chunk =  np.dot(chunk, transform.T).copy()
            # normalize the input patches
            normal = np.atleast_2d(np.sqrt(((chunk*chunk).sum(1))/(3*nrp*nrp) + small)).T
            chunkn = chunk / normal

            # compute features              
            feat = np.dot(chunkn,param["VF"]) # PxF
            feat = (feat*feat).copy()
            temp = - np.dot(feat,param["FH"]) + param["bias_cov"].T # PxO
            feature[:,0:nrf1,rr,cc] = 1. / (1 + np.exp(-temp)) 
            temp2 = np.dot(chunk,param["w_mean"]) + param["bias_mean"].T # PxF
            feature[:,nrf1:nrf,rr,cc] = 1. / (1 + np.exp(-temp2)) # p
    feature = reshape(feature,(numcases,nrf*steps*steps),'F')
    # back up here...
